#!/usr/bin/env python3
# -*- coding: utf-8 -*-
#
# STEMsalabim documentation build configuration file, created by
# sphinx-quickstart on Wed Jun 21 08:54:44 2017.
#
# This file is execfile()d with the current directory set to its
# containing dir.
#
# Note that not all possible configuration values are present in this
# autogenerated file.
#
# All configuration values have a default; values that are commented out
# serve to show the default.

import re
import os
on_rtd = os.environ.get('READTHEDOCS') == 'True'

# If extensions (or modules to document with autodoc) are in another directory,
# add these directories to sys.path here. If the directory is relative to the
# documentation root, use os.path.abspath to make it absolute, like shown here.
#
# import os
# import sys
# sys.path.insert(0, os.path.abspath('.'))


# -- General configuration ------------------------------------------------

# If your documentation needs a minimal Sphinx version, state it here.
#
# needs_sphinx = '1.0'

# Add any Sphinx extension module names here, as strings. They can be
# extensions coming with Sphinx (named 'sphinx.ext.*') or your custom
# ones.
extensions = ['sphinx.ext.mathjax']

# The suffix(es) of source filenames.
# You can specify multiple suffix as a list of string:
#
# source_suffix = ['.rst', '.md']
source_suffix = '.rst'

# The master toctree document.
master_doc = 'index'

def get_version_from_cmakelists():
    info = {}
    with open("../CMakeLists.txt") as cm:
        for line in cm:
            m = re.match("set\s*\(\s*(PACKAGE_VERSION_MAJOR|PACKAGE_VERSION_MINOR|PACKAGE_VERSION_PATCH|PACKAGE_NAME|PACKAGE_DESCRIPTION|PACKAGE_AUTHOR|PACKAGE_AUTHOR_EMAIL)[\s\"']+([^\"']+)[\s\"']+", line)
            if m:
                info[m.group(1)] = m.group(2)
    return info

project_info = get_version_from_cmakelists()

# General information about the project.
project = project_info["PACKAGE_NAME"]
copyright = project_info["PACKAGE_AUTHOR"]
author = project_info["PACKAGE_AUTHOR"]

html_logo = "images/Logo.png"

# The version info for the project you're documenting, acts as replacement for
# |version| and |release|, also used in various other places throughout the
# built documents.
#
# The short X.Y version.
version = project_info["PACKAGE_VERSION_MAJOR"] + "." + project_info["PACKAGE_VERSION_MINOR"]
# The full version, including alpha/beta/rc tags.
release = project_info["PACKAGE_VERSION_MAJOR"] + "." + project_info["PACKAGE_VERSION_MINOR"] + "." + project_info["PACKAGE_VERSION_PATCH"]

# The language for content autogenerated by Sphinx. Refer to documentation
# for a list of supported languages.
#
# This is also used if you do content translation via gettext catalogs.
# Usually you set "language" from the command line for these cases.
language = None

# List of patterns, relative to source directory, that match files and
# directories to ignore when looking for source files.
# This patterns also effect to html_static_path and html_extra_path
exclude_patterns = []

# The name of the Pygments (syntax highlighting) style to use.
pygments_style = 'sphinx'

# If true, `todo` and `todoList` produce output, else they produce nothing.
todo_include_todos = False


# -- Options for HTML output ----------------------------------------------

# The theme to use for HTML and HTML Help pages.  See the documentation for
# a list of builtin themes.
#
if not on_rtd:
    try:
        import sphinx_rtd_theme
        html_theme = "sphinx_rtd_theme"
        html_theme_path = [sphinx_rtd_theme.get_html_theme_path()]
    except:
        pass

# Theme options are theme-specific and customize the look and feel of a theme
# further.  For a list of options available for each theme, see the
# documentation.
#
# html_theme_options = {}

# Add any paths that contain custom static files (such as style sheets) here,
# relative to this directory. They are copied after the builtin static files,
# so a file named "default.css" will overwrite the builtin "default.css".
#html_static_path = ['@PROJECT_SOURCE_DIR@/docs/_static']


# -- Options for HTMLHelp output ------------------------------------------

# Output file base name for HTML help builder.
htmlhelp_basename = 'STEMsalabimdoc'


# -- Options for LaTeX output ---------------------------------------------

latex_elements = {
    # The paper size ('letterpaper' or 'a4paper').
    #
    'papersize': 'a4paper',

    # The font size ('10pt', '11pt' or '12pt').
    #
    # 'pointsize': '10pt',

    # Additional stuff for the LaTeX preamble.
    #
    # 'preamble': '',

    # Latex figure (float) alignment
    #
    # 'figure_align': 'htbp',
}

# Grouping the document tree into LaTeX files. List of tuples
# (source start file, target name, title,
#  author, documentclass [howto, manual, or own class]).
latex_documents = [
    (master_doc, 'STEMsalabim.tex', 'STEMsalabim Documentation',
     'Jan Oliver Oelerich', 'manual', True),
]


# -- Options for manual page output ---------------------------------------

# One entry per manual page. List of tuples
# (source start file, name, description, authors, manual section).
man_pages = [
    (master_doc, 'stemsalabim', 'STEMsalabim Documentation',
     [author], 1)
]


# -- Options for Texinfo output -------------------------------------------

# Grouping the document tree into Texinfo files. List of tuples
# (source start file, target name, title, author,
#  dir menu entry, description, category)
texinfo_documents = [
    (master_doc, 'STEMsalabim', 'STEMsalabim Documentation',
     author, 'STEMsalabim', 'One line description of project.',
     'Miscellaneous'),
]



